<?php

namespace App\Controller;

use App\Entity\Theme;
use App\Repository\ExamenRepository;
use App\Repository\UserThemeRepository;
use ContainerMkOx83x\PaginatorInterface_82dac15;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class AcceuilController extends AbstractController
{
    /**
     * @Route("/acceuil", name="acceuil")
     */
    public function index(UserThemeRepository $UserThemeRepository, Request $request): Response
    {
        $msg = null;
        if($request->query->get('valide'))
        {
            if($request->query->get('valide') == 1)
            {
                $resultat = $request->query->get('resultat');
                $msg = "Félicitations! Vous avez passé l'examen avec success avec $resultat%" ;
            }
            
        }

        $rolesTab = $this->getUser()->getRoles();
        if (in_array('ROLE_ADMIN', $rolesTab, true))
        {
            return $this->redirectToRoute('theme_index');
        }
        return $this->render('acceuil/index.html.twig', [
            'controller_name' => 'AcceuilController',
            'userthemes' => $UserThemeRepository->findAll(),
            'msg' => $msg
        ]);
    }

    /**
     * @Route("/student/examens/{id}", name="list_examen")
     */
    public function examens(Request $request, Theme $theme, ExamenRepository $examenRepository): Response
    {
        return $this->render('acceuil/examens.html.twig', [
            'examens' => $examenRepository->findBy([
                'theme' => $theme->getId() 
            ]    
            ),
        ]);
    }

    
}
