<?php

namespace App\Controller;

use App\Repository\ExamenRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class AdminController extends AbstractController
{
    /**
     * @Route("/admin", name="admin")
     */
    public function index(): Response
    {
        return $this->render('admin/index.html.twig', [
            'controller_name' => 'AdminController',
        ]);
    }

    /**
     * @Route("/search", name="search_for")
     */
    public function search(ExamenRepository $examenRepository, Request $request): Response
    {
        $libelle = $request->request->get('libelle');
        $examens = $examenRepository->search($libelle);
        $examen = $examenRepository->find($examens);
        return $this->render('admin/search.html.twig',[
            'examen' => $examen
        ]);
    }
}
