<?php

namespace App\Controller;

use App\Entity\Examen;
use App\Entity\Question;
use App\Repository\ChoixRepository;
use App\Repository\QuestionRepository;
use DateTime;
use Knp\Component\Pager\PaginatorInterface;
use SebastianBergmann\CodeCoverage\Report\Html\Renderer;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class PasserExamenController extends AbstractController
{
    /**
     * @Route("/passer/{id}", name="passer_examen", methods={"GET" , "POST"})
     */
    public function index(Request $request, Examen $examen, QuestionRepository $qr, ChoixRepository $cr): Response
    {
        $s = $request->getSession();
        
        $res = 100/count($examen->getQuestions());
        $error = null;
        $i=0;

        if ($request->request->get('qst')) {
            $i++;
            $question = $qr->find($request->request->get('qst'));
            if ($request->request->get('q' . $question->getId()) || $request->request->get('skip') == 1) {
                if($request->request->get('skip') != 1){
                    $choix = $cr->find($request->request->get('q' . $question->getId()));
                    if ($choix->getVraiFaux()){
                        $s->set('resultat',$s->get('resultat')+$res);
                        
                        $s->set('correcte',$s->get('correcte')+1);
                        if($s->get('resu')) $resu = $s->get('resu');
                        else $resu = array();
                        array_push($resu,$question->getPriorite());
                        $s->set("resu",$resu);
                        //pour le resultat
                        $s->set("Question$i",'1');
                        $s->set("RepQuestion$i",$choix);
                        
                    }else{
                        $s->set('faux',$s->get('faux')+1);
                    }
                }
                else{
                    $s->set('faux',$s->get('faux')+1);
                }
               

                $priorite = $question->getPriorite() + 1;
                $left = count($examen->getQuestions()) - $priorite;
                $Nextquestion = $qr->findOneBy(["priorite" => $priorite, "examen" => $examen]);
                if ($Nextquestion){
                    $question = $Nextquestion;
                    $s->set('question',$question);
                } 
                // Fin D'examen
                else{
                    if($examen->getTheme()->getTauxValidation() <= $s->get('resultat'))$valid= '1';
                    else $valid = '0';
                    $resultat=$s->get('resultat');
                    $correcte = $s->get('correcte');
                    $faux = $s->get('faux');
                    $result=$s->get('resu');
                    $s->clear();
                    

                    return $this->render('passer_examen/quiz-result.html.twig',[
                            'res'=>$result,
                            'valide' => $valid,
                             'resultat' => $resultat,
                             'id' => $examen->getId(),
                             'examen' => $examen,
                             'question' => $question,
                             'error'=>$error,
                             'faux'=>$faux,
                             'correcte'=>$correcte,
                         ]);                        
                        
                        
                }
            }else{
                $left = count($examen->getQuestions()) - $question->getPriorite();
                $error='Veuillez saisir une reponse';
            }
            
        } else {
            if ($s->get('question')) {
                $question= $s->get('question');   
            
            }else{
                $question = $qr->findOneBy([
                    "priorite" => 1,
                    "examen" => $examen
                ]);
                $date=new DateTime('NOW');
                $s->set('user',$this->getUser());
                $s->set('dateStart',$date);
                $s->set('resultat',0);
                $s->set('question',$question);
            }

            
            $left = count($examen->getQuestions()) - $question->getPriorite();
        }
        return $this->render('passer_examen/take-quiz.html.twig', [
            'examen' => $examen,
            'left' => $left,
            'question' => $question,
            'error'=>$error,
            'faux'=>$s->get('faux'),
            'correcte'=>$s->get('correcte')
        ]);
    }

    //  /**
    //  * @Route("/resultat/{id}", name="result_index")
    //  */
    // public function examens(Request $request, PaginatorInterface $paginator): Response
    // {
    //     dd($request);

    //     $donnees = $request->attributes->get('id')->getQuestions();

    //                 $questionss = $paginator->paginate(
    //                     $donnees,
    //                     $request->query->getInt('page', 1),
    //                     1
    //                 );

    //     return $this->render('passer_examen/quiz-result.html.twig',[
    //         'res'=>$request->query->get('result'),
    //         'valide' => $request->query->get('valid'),
    //         'resultat' => $request->query->get('resultat'),
    //         'id' => $request->attributes->get('id'),
    //         'examen' => $request->attributes->get('id'),
    //         'error'=>$request->query->get('error'),
    //         'faux'=>$request->query->get('faux'),
    //         'correcte'=>$request->query->get('correcte'),
    //         'questionss'=>$questionss
    //     ]);
    // }
}

